unit maho1;

interface

uses
  ComObj, ActiveX, AxCtrls, maho_TLB,forms;

type
  TMaho = class(TAutoObject, IConnectionPointContainer, IMaho)
  private
    { Private declarations }
    FConnectionPoints: TConnectionPoints;
    FEvents: IMahoEvents;
  public
    procedure Initialize; override;
  protected
    { Protected declarations }
    property ConnectionPoints: TConnectionPoints read FConnectionPoints
      implements IConnectionPointContainer;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Step(const S: WideString): Integer; safecall;
    function CloseDll:integer; safecall;
    function StartDll(const S: WideString): Integer; safecall;
  end;

implementation

uses ComServ,dialogs;
var v:variant;

procedure TMaho.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IMahoEvents;
end;

procedure TMaho.Initialize;
begin
  inherited Initialize;
  FConnectionPoints := TConnectionPoints.Create(Self);
  if AutoFactory.EventTypeInfo <> nil then
    FConnectionPoints.CreateConnectionPoint(AutoFactory.EventIID,
      ckSingle, EventConnect);
end;

function TMaho.StartDll(const S: WideString): Integer;
begin
  result:=1;
  try
  v:=CreateOleObject(s);
  except
if VarType(v)=VarEmpty then
  begin
   Showmessage('Pre-Processor Can''t Link to Inplot');
   result:=0;
   Application.Terminate;
  end;
  end;
end;

function TMaho.Step(const S: WideString): Integer;
begin
// this receives the current line from inplot
// put any processing of string here

// then send it back to Inplot to plot
 v.plot(s);
// display it in Inplot prompt window just for fun
 v.prompt(s);

 result:=1;
end;

function TMaho.CloseDll:integer;
begin
 Application.Terminate
end;

initialization
  TAutoObjectFactory.Create(ComServer, TMaho, Class_Maho_,
    ciMultiInstance, tmApartment);
end.
